﻿using Syncfusion.DataSource;
using Syncfusion.DataSource.Extensions;
using Syncfusion.ListView.XForms;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;

namespace Grouping
{
    public partial class GroupingPage : ContentPage
    {
        #region Fields

        bool CanExpand = false;
        Image image;

        #endregion

        #region Constructor

        public GroupingPage()
        {
            InitializeComponent();
            listView.ItemSize = 0;
            listView.DataSource.GroupDescriptors.Add(new GroupDescriptor()
            {
                PropertyName = "Group",
                KeySelector = (object obj1) =>
                {
                    var item = (obj1 as Contacts);
                    return item.Group;
                },
            });
            listView.CollapseAll();
            listView.ItemTapped += ListView_ItemTapped;
            listView.GroupCollapsing += ListView_GroupCollapsing;
            listView.GroupExpanding += ListView_GroupExpanding;
        }

        #endregion

        #region Private Method

        private void CreateItem()
        {
            listView.ItemSize = 70;
            DisplayAlert("AddItem", "Implement to Add the item", "Ok");
        }

        #endregion

        #region CallBacks

        private void ListView_GroupExpanding(object sender, GroupExpandCollapseChangingEventArgs e)
        {
            e.Cancel = listView.ItemSize == 0;
        }

        private void ListView_GroupCollapsing(object sender, GroupExpandCollapseChangingEventArgs e)
        {
            e.Cancel = listView.ItemSize == 0;
        }

        private void ListView_ItemTapped(object sender, Syncfusion.ListView.XForms.ItemTappedEventArgs e)
        {
            var group = e.ItemData as GroupResult;
            if (group != null && group.Count == 1)
            {
                var tempcontact = group.Items.ToList<Contacts>();
                listView.DataSource.LiveDataUpdateMode = LiveDataUpdateMode.AllowDataShaping;
                CanExpand = tempcontact.Any(contact => contact.ContactName.Equals(""));

                if (CanExpand)
                    listView.ItemSize = 0;
            }
        }

        private void Image_BindingContextChanged(object sender, EventArgs e)
        {
            //if (image == null)
            {
                image = sender as Image;
                (image.Parent as View).GestureRecognizers.Add(new TapGestureRecognizer() { Command = new Command(CreateItem) });
            }
        }

        #endregion
    }
}
